; 16_SUM_02.a51 	Lab 21, mu2: 16-bit running sum & display
	
    $NOSYMBOLS        ; keeps listing short

; default Ride7 path, Mar. 16
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\REG320.INC) 
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\vectors320.INC)

	ORG 0			; tells assembler the address at which to place this code
	
	SJMP STARTUP		; 	here code begins--with just a jump to start of
							;   real program.  ALL our programs will start thus
							
	ORG 60h				;  ...and here the program starts
	
STARTUP:	MOV DPTR, #8000h	; "point" to low byte of display, and to keypad
						
			CLR A
			MOV R0, A			; clear storage registers
			MOV R1, A
									
			
GETIT:	MOVX A, @DPTR		; read the keypad
			ADD A,R0				; form low-half of running sum 
			MOVX @DPTR, A		; ...send it to display (port 0)
			MOV R0,A				; and save a copy in register
					
			CLR A
			ADDC A,R1			; increment high-byte of running sum (takes in Cy, if we've overflowed low byte
			MOV R1,A				; ...save result
			
			INC DPTR				; point to high-half of display (port 1)
			MOVX @DPTR, A		; ...send high byte to display (port 0)
			DEC DPL				; restore pointer to low-byte (there is no 16-bit ptr dec,
									;  but this modest dec is safe; done once from 8001,
									;  it can't generate a borrow
			SJMP GETIT
			
			END
									
									
